unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs,
  ppComm, ppRelatv, rsServer;

type
  TService1 = class(TService)
    rsServer1: TrsServer;
    procedure ServiceStart(Sender: TService; var Started: Boolean);
    procedure ServiceStop(Sender: TService; var Stopped: Boolean);
    procedure ServiceShutdown(Sender: TService);
    procedure ServiceContinue(Sender: TService; var Continued: Boolean);
    procedure ServicePause(Sender: TService; var Paused: Boolean);
  private

    function StartReportServer: Boolean;
    function StopReportServer: Boolean;

  public
    function GetServiceController: TServiceController; override;


  end;

var
  Service1: TService1;

implementation

{$R *.DFM}

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  Service1.Controller(CtrlCode);
end;

function TService1.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

function TService1.StartReportServer: Boolean;
begin
  rsServer1.Active := True;
  Result := rsServer1.Active;

end;

function TService1.StopReportServer: Boolean;
begin
  rsServer1.Active := False;
  Result := not(rsServer1.Active);

end;

procedure TService1.ServiceStart(Sender: TService; var Started: Boolean);
begin
  Started := StartReportServer;
end;

procedure TService1.ServiceStop(Sender: TService; var Stopped: Boolean);
begin
  Stopped := StopReportServer;

end;

procedure TService1.ServiceShutdown(Sender: TService);
begin
  StopReportServer;

end;

procedure TService1.ServiceContinue(Sender: TService; var Continued: Boolean);
begin
  StartReportServer;
end;

procedure TService1.ServicePause(Sender: TService; var Paused: Boolean);
begin
  StopReportServer;
end;

end.
