{ RRRRRR                  ReportBuilder Class Library                  BBBBB
  RR   RR                                                              BB   BB
  RRRRRR                 Digital Metaphors Corporation                 BB BB
  RR  RR                                                               BB   BB
  RR   RR                   Copyright (c) 1996-2004                    BBBBB   }


unit myService;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs,
  ppComm, ppRelatv, rsServer;

type

 {This example shows how to run a report server as a windows service application.

  This is an alternative to the ReportBuilder Services application that is incuded
  with ReportBuilder Server Edition. ReportBuilder Services is limited to one
  instance per machine. Use this example to run multiple report servers on a
  single machine.

  1. Use Object Inspector to modify the TService properties such as
     Name and DisplayName.

  2. Use the Object Inspector to configure the TrsServerPropertie such as
     Port. Currently Port is set to 1334.

  3. To install the windows service run this application with a /INSTALL parameter.
     (Use the Delphi Run | Parameters dialog).

  4. To uninstall the windows service run this application with the /UNINSTALL
     parameter.

  }


  TmyReportService1 = class(TService)
    rsServer1: TrsServer;
    procedure ServiceStart(Sender: TService; var Started: Boolean);
    procedure ServiceStop(Sender: TService; var Stopped: Boolean);
    procedure ServiceShutdown(Sender: TService);
    procedure ServiceContinue(Sender: TService; var Continued: Boolean);
    procedure ServicePause(Sender: TService; var Paused: Boolean);
  private

    function StartReportServer: Boolean;
    function StopReportServer: Boolean;

  public
    function GetServiceController: TServiceController; override;


  end;

var
  myReportService1: TmyReportService1;

implementation

{$R *.DFM}

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  myReportService1.Controller(CtrlCode);
end;

function TmyReportService1.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

{------------------------------------------------------------------------------}
{ TmyReportService1.StartReportServer }

function TmyReportService1.StartReportServer: Boolean;
begin
  rsServer1.Active := True;
  Result := rsServer1.Active;

end;

{------------------------------------------------------------------------------}
{ TmyReportService1.StopReportServer }

function TmyReportService1.StopReportServer: Boolean;
begin
  rsServer1.Active := False;
  Result := not(rsServer1.Active);

end;

{------------------------------------------------------------------------------}
{ TmyReportService1.ServiceStart }

procedure TmyReportService1.ServiceStart(Sender: TService; var Started: Boolean);
begin
  StartReportServer;
end;

{------------------------------------------------------------------------------}
{ TmyReportService1.ServiceStop }

procedure TmyReportService1.ServiceStop(Sender: TService; var Stopped: Boolean);
begin
  Stopped := StopReportServer;
end;

{------------------------------------------------------------------------------}
{ TmyReportService1.ServiceShutdown }

procedure TmyReportService1.ServiceShutdown(Sender: TService);
begin
  StopReportServer;

end;

{------------------------------------------------------------------------------}
{ TmyReportService1.ServiceContinue }

procedure TmyReportService1.ServiceContinue(Sender: TService; var Continued: Boolean);
begin
  StartReportServer;
end;

{------------------------------------------------------------------------------}
{ TmyReportService1.ServicePause }

procedure TmyReportService1.ServicePause(Sender: TService; var Paused: Boolean);
begin
  StopReportServer;
end;

end.
