{ RRRRRR                  ReportBuilder Class Library                  BBBBB
  RR   RR                                                              BB   BB
  RRRRRR                 Digital Metaphors Corporation                 BB BB
  RR  RR                                                               BB   BB
  RR   RR                   Copyright (c) 1996-2002                    BBBBB   }

unit rbReportTemplateVolume;

interface

uses
  SysUtils, Classes, DBTables, DB, Graphics,
  ppComm, ppDB, ppClass, ppCtrls, ppVar, ppBands, ppReport,
  rsReportVolume, rsReportVolumeStorage, rsReportVolumeTemplate,
  daDataModule,
  daDBBDE, {DADE BDE support }
  ppFileUtils, daDataView, daQueryDataView, ppModule, ppStrtch, ppSubRpt,
  ppPrnabl, ppCache, ppRelatv, ppProd;

type

  TdmReportTemplateVolume = class(TDataModule)
    Database1: TDatabase;
    Session1: TSession;
    rsReportTemplateVolume1: TrsReportTemplateVolume;

    {rb004Sections}
    procedure ppEmpSalesGroupFooterBand1BeforePrint(Sender: TObject);
    procedure ppLabelContinuedPrint(Sender: TObject);
    procedure ppStockListDetailBeforePrint(Sender: TObject);

    {rb005CustomerOrderItem}
    procedure varItemTotalCalc(Sender: TObject; var Value: Variant);
    procedure varOrderTotalCalc(Sender: TObject; var Value: Variant);
    procedure ppDetailBand1BeforePrint(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    
  private

    function GetDataPipelineForName(aList: TList; const aComponentName: String): TppDataPipeline;

  public
    { Public declarations }
  end;

var
  dmReportTemplateVolume: TdmReportTemplateVolume;

implementation

{$R *.dfm}



procedure TdmReportTemplateVolume.DataModuleCreate(Sender: TObject);
begin

  rsReportTemplateVolume1.FileDirectory := TppFileUtils.GetApplicationFilePath + 'Report Files';

end;


{rb004Sections}

procedure TdmReportTemplateVolume.ppEmpSalesGroupFooterBand1BeforePrint(Sender: TObject);
var
  lReport: TppCustomReport;
  lDBCalcSum: TppDBCalc;
  lCalcNet: TppVariable;
begin
  lReport := TppGroupBand(Sender).Group.Report;
  lCalcNet := TppVariable(lReport.FindUserObject('ppCalcNet1'));
  lDBCalcSum := TppDBCalc(lReport.FindUserObject('ppDBCalcSumSales'));

  lCalcNet.AsFloat := lDBCalcSum.Value - lReport.DataPipeline['Salary'];

  if lCalcNet.AsFloat < 0 then
   lCalcNet.Font.Color := clRed
  else
   lCalcNet.Font.Color := clBlack;
end;

procedure TdmReportTemplateVolume.ppLabelContinuedPrint(Sender: TObject);
var
  lLabel: TppLabel;
  lReport: TppCustomReport;
begin
  lLabel := TppLabel(Sender);

  lReport := lLabel.Band.Report;

  if not(lReport.Groups[0].FirstPage) and (TppBandedReport(lReport).Detail.Count = 1) then
    lLabel.Visible := True
  else
    lLabel.Visible := False;
end;

procedure TdmReportTemplateVolume.ppStockListDetailBeforePrint(Sender: TObject);
var
  lReport: TppCustomReport;
  lsRecommendation: String;
  lFontColor: TColor;
  lDBTextRcmndation: TppDBText;
  lDBTextSymbol: TppDBText;
begin

  lReport := TppBand(Sender).Report;
  lsRecommendation := lReport.DataPipeline['Rcmndation'];

  {determine the font color based on the value of Recommendation}
  if lsRecommendation = 'BUY' then
    lFontColor := clRed

  else if lsRecommendation = 'HOLD' then
    lFontColor := clGreen

  else {lsRecommendation = 'SELL'}
    lFontColor := clBlue;

  lDBTextRcmndation := TppDBText(lReport.FindUserObject('ppDBTextRcmndation'));
  lDBTextSymbol := TppDBText(lReport.FindUserObject('ppDBTextSymbol'));

  {set the font color of Symbol, Recommendation variables}
  lDBTextRcmndation.Font.Color := lFontColor;
  lDBTextSymbol.Font.Color := lFontColor;

end;

{rb005CustomerOrderItem}

procedure TdmReportTemplateVolume.varItemTotalCalc(Sender: TObject; var Value: Variant);
var
  lReport: TppCustomReport;
  lDataModule: TdaDataModule;
  lDataPipelines: TList;
  lItem: TppDataPipeline;
  lPart: TppDataPipeline;
  lItemTotal: TppVariable;
begin

  lReport := TppVariable(Sender).Band.Report;
  lDataModule := TdaDataModule(lReport.MainReport.GetModuleForClass(TdaDataModule));

  lDataPipelines := TList.Create;

  lDataModule.GetDataPipelines(lDataPipelines);

  lItem := GetDataPipelineForName(lDataPipelines, 'Items');
  lPart := GetDataPipelineForName(lDataPipelines, 'Parts');

  {calculate item subreport's item total, ItemTotal = Quantity * Price }
  lItemTotal := TppVariable(lReport.FindUserObject('varItemTotal'));

  lItemTotal.Value := lItem['Qty'] * lPart['ListPrice'];

  lDataPipelines.Free;

end;

procedure TdmReportTemplateVolume.varOrderTotalCalc(Sender: TObject; var Value: Variant);
var
  lReport: TppCustomReport;
  lItemTotal: TppVariable;
begin
  lReport := TppVariable(Sender).Band.Report;

  lItemTotal := TppVariable(lReport.FindUserObject('varItemTotal'));

  {calculate item subreport's order total, OrderTotal = Sum(ItemTotal)}
  Value := Value + lItemTotal.Value;
end;

procedure TdmReportTemplateVolume.ppDetailBand1BeforePrint(Sender: TObject);
var
  lReport: TppCustomReport;
  lContinued: TppLabel;
begin
  lReport := TppBand(Sender).Report;

  lContinued := TppLabel(lReport.FindUserObject('lblContinued'));

  {when the detail band of the order subreport overflows, show continued label}
  lContinued.Visible := TppBandedReport(lReport).Detail.OverFlow;
end;

function TdmReportTemplateVolume.GetDataPipelineForName(aList: TList; const aComponentName: String): TppDataPipeline;
var
  liIndex: Integer;
  lDataPipeline: TppDataPipeline;
begin

  Result := nil;

  liIndex := 0;

  while (Result = nil) and (liIndex < aList.Count) do
    begin
      lDataPipeline := TppDataPipeline(aList[liIndex]);

      if (CompareText(lDataPipeline.Name, aComponentName) = 0) then
        Result := lDataPipeline
      else
        Inc(liIndex);
    end;

end;


end.
